
#include "player_set.h"

class  Near_Player_Predicate : public Player_Predicate_Entity
{
protected:
	D2_Vector self_position ;
	double	  check_dist ;
public:
	Near_Player_Predicate( D2_Vector self_position , double dist )
		: self_position( self_position ),check_dist(dist) {}

	virtual	~Near_Player_Predicate() {}
	virtual	bool	operator () ( const Player_Reference & ) const ;
};

#include "range.h"

class X_Range_Player_Predicate :public Player_Predicate_Entity
{
protected:
	Double_Range	x_range ;
public:
	X_Range_Player_Predicate( const Double_Range & range )
		: x_range ( range ) {}

	X_Range_Player_Predicate(double min_x , double max_x)
		: x_range ( min_x, max_x ) {}

	virtual	~X_Range_Player_Predicate() {}
	virtual	bool	operator () ( const Player_Reference & ) const ;
};

class Y_Range_Player_Predicate :public Player_Predicate_Entity
{
protected:
	Double_Range	y_range ;
public:
	Y_Range_Player_Predicate( const Double_Range & range )
		: y_range ( range ) {}

	Y_Range_Player_Predicate(double min_y , double max_y)
		: y_range ( min_y, max_y ) {}

	virtual	~Y_Range_Player_Predicate() {}
	virtual	bool	operator () ( const Player_Reference & ) const ;
};
